/***************************************************************************
 *   Copyright (C) 2005 by Hector Blanco de Frutos                         *
 *   hectorblanco@neopontec.com                                            *
 *   Go to LICENSE file to read the license agreement                      *
 ***************************************************************************/
 
#include "engine.h"
#include <stdlib.h>
#include <iostream>


#include "debug.h"

using namespace std;

// Get an string showing the current NNGEngine version
// Get an string showing the current NNGEngine version
string NNG_EngineVersion(){
	//*****************************************************
	// Engine version variables (don't edit it, please)
	int major=0;
	int minor=0;
	int build=4;
	string codename, nameversion;
	char str[128];
	codename="(Lleida)";
	sprintf(str,"%i.%i.%i ",major,minor,build);
	//*****************************************************
	//Print the engine version
	//	sprintf(nameversion,"NNG Engine version %i.%i.%i (%s)",major,minor,build, codename);
	nameversion=string("NNG Engine Version ") + str + codename; 
	//fp = (float *)malloc(sizeof(float));
	//str = (char *) malloc (strlen(str_temp)); //Allocate string pointer
	return nameversion;
	//free(str);  //Free used memory
}

// Engine start function
SDL_Surface *NNG_EngineInit( NNG_EngineOptions &engine_options){
	SDL_Surface *screen;
	strcpy(engine_options.engine_version,NNG_EngineVersion().c_str());
	//engine_options.engine_version = (char *) malloc (strlen(str_temp)); //Allocate string pointer
	// Show some engine information
	printf("\n%s - %s\n",engine_options.engine_version,"Copyright (c) Hector Blanco. 2005");
	printf("Pubblished by NEOPONTEC under the terms of the LGPL License \n\n");
	
	// Initialize SDL
    printf("Starting SDL library ...\n");
    if (SDL_Init (SDL_INIT_AUDIO | SDL_INIT_VIDEO | SDL_INIT_JOYSTICK) < 0)
    {	
    	printf("ERROR starting SDL: %s . The engine will close.\n" , SDL_GetError());
        exit (1);
    }
    // Initialize the Joystick
    
    
    
    // Initialize SDL_Mixer
      printf("Starting SDL_Mixer library ...\n");
      if (Mix_OpenAudio(22050, AUDIO_S16SYS, 2, 128) < 0)
  		{
    		printf("Warning: Couldn't set 44100 Hz 16-bit audio\n- Reason: %s\n",
							SDL_GetError());
  		}
	

	//Initialize main game surface
	printf("Creating video surface ...\n");
    screen = SDL_SetVideoMode (engine_options.wres, engine_options.hres, engine_options.depth, SDL_SWSURFACE);
    if (screen == NULL)
    {
    	printf("Error creating the default game surface\n");
    }
    
	
    printf("Starting SDL_ttf library ...\n");
    if(TTF_Init()==-1) {
    	printf("ERROR starting SDL_ttf: %s\n", TTF_GetError());
    	exit(2);
	}
    
    
	return screen;	
}
