/***************************************************************************
 *   Copyright (C) 2005 by Hector Blanco de Frutos                         *
 *   hectorblanco@neopontec.com                                            *
 *   Go to LICENSE file to read the license agreement                      *
 ***************************************************************************/
 
 /**************************************************************************
  * This code part was inspired by the SDL GFX tutorials at 
  * http://cone3d.gamedev.net , made by Marius Andra
  **************************************************************************/
  
#ifndef _SPRITES_H_
#define _SPRITES_H_

#endif //_SPRITES_H_

// The sprite helper structure
struct NNG_SpriteFrame
{
  SDL_Surface *image;
  int pause;
};

// The base structure for sprites
class NNG_SpriteBase
{
  public:
  int init(char *dir);

  NNG_SpriteFrame *mAnim;
  int mBuilt, mNumframes, mW, mH;
};


class NNG_Sprite
{
  public:
  NNG_Sprite() {}
  ~NNG_Sprite() {};
  int init(NNG_SpriteBase *base, SDL_Surface *screen);
  void draw();
  void clearBG();
  void updateBG();

  void setFrame(int nr) { mFrame = nr; }
  int getFrame() { return mFrame; }

  void setSpeed(float nr) { mSpeed = nr; }
  float getSpeed() { return mSpeed; }

  void toggleAnim() { mAnimating = !mAnimating; }
  void startAnim() { mAnimating = 1; }
  void stopAnim() { mAnimating = 0; }
  void rewind() { mFrame = 0; }

  void xadd(int nr) { mX+=nr; }
  void yadd(int nr) { mY+=nr; }
  void xset(int nr) { mX=nr; }
  void yset(int nr) { mY=nr; }
  void set(int xx, int yy) { mX=xx; mY=yy; }

  float getx() {return mX;}
  float gety() {return mY;}
  
  int getw() {return mSpriteBase->mAnim[0].image->w;}
  int geth() {return mSpriteBase->mAnim[0].image->h;}
  
  private:
  int mFrame;
  int mX, mY, mOldX, mOldY;
  int mAnimating;
  int mDrawn;
  float mSpeed;
  long mLastupdate;
  NNG_SpriteBase *mSpriteBase;
  SDL_Surface *mBackreplacement;
  SDL_Surface *mScreen;
};

short int Sprite_Collide(NNG_Sprite &object1, NNG_Sprite &object2);
