/***************************************************************************
 *   Copyright (C) 2005 by Hector Blanco de Frutos                         *
 *   hectorblanco@neopontec.com                                            *
 *   Go to LICENSE file to read the license agreement                      *
 ***************************************************************************/
 
 
#include "engine.h"

// Load an image file
SDL_Surface *LoadIMG(char* file)
{
	return(IMG_Load(file));
    
}    

//Draw a surface to the screen surface
void DrawIMG(SDL_Surface *screen, SDL_Surface *img, int x, int y)
{
    SDL_Rect dest; 
    dest.x = x; 
    dest.y = y;  
    SDL_BlitSurface(img, NULL, screen, &dest); 
}

// Blit a portion of an image on the screen surface
void DrawIMG(SDL_Surface *screen, SDL_Surface *img, int x, int y, int w, int h, int x2, int y2)
{
  SDL_Rect dest;
  dest.x = x;
  dest.y = y;
  SDL_Rect dest2;
  dest2.x = x2;
  dest2.y = y2;
  dest2.w = w;
  dest2.h = h;
  SDL_BlitSurface(img, &dest2, screen, &dest);
}
/*
//Draw a text to a surface
void DrawTXT(SDL_Surface *screen, TTF_Font *font, const char *text, int x, int y, SDL_Color color1){
    SDL_Surface *textsurface;
    textsurface=TTF_RenderText_Blended(font,text,color1);
    DrawIMG(screen, textsurface, x, y);
    SDL_FreeSurface(textsurface);
}

void DrawTXT_Shaded(SDL_Surface *screen, TTF_Font *font, const char *text, int x, int y, SDL_Color color1, SDL_Color shadowcolor){
    SDL_Surface *textsurface;
    textsurface=TTF_RenderText_Shaded(font,text,color1, shadowcolor);
    DrawIMG(screen, textsurface, x, y);
    SDL_FreeSurface(textsurface);
}     
*/

// Initialize some colors
NNG_colors NNG_InitColors(){
	printf("Setting pre-defined color schemas ...\n");
	
    NNG_colors color1;
    //Black
    color1.black.r=0;
    color1.black.g=0;
    color1.black.b=0;
    //White
    color1.white.r=255;
    color1.white.g=255;
    color1.white.b=255;   
    //Violet
    color1.violet.r=185;
    color1.violet.g=0; 
    color1.violet.b=255;
    //VioletBlue
    color1.violetblue.r=165;
    color1.violetblue.g=115; 
    color1.violetblue.b=255;
    //Yelloy
    color1.yellow.r=255;
    color1.yellow.g=255;
    color1.yellow.b=0;  
    //Dark Yelloy
    color1.darkyellow.r=217;
    color1.darkyellow.g=207;
    color1.darkyellow.b=44;     
    //Light Blue
    color1.lightblue.r=155;
    color1.lightblue.g=255;
    color1.lightblue.b=255;     
           
    return color1;
}    
