/***************************************************************************
 *   Copyright (C) 2005 by Hector Blanco de Frutos                         *
 *   hectorblanco@neopontec.com                                            *
 *   Go to LICENSE file to read the license agreement                      *
 ***************************************************************************/
 
#include "SDL/SDL.h"
#include "screens/screens.h"
#include "base/engine.h"
#include <stdlib.h>


#include "base/debug.h"


//Global personal variables
SDL_Surface *screen=NULL;
NNG_colors gamecolor;
NNG_EngineOptions game_options;
string game_version="0.1.2";
SDL_Joystick *joy;

// Game init function
int main(int argc, char *argv[]){
    
    
	// Set some engine options
	game_options.depth=16; //24 bpp
	game_options.wres=320; // Width resolution
	game_options.hres=240; //Heigth resolution
	game_options.SDL_ttf_enabled=1;   //Enable SDL_ttf
	game_options.SDL_image_enabled=1;  //Enable SDL_image
    



    // Start the NNG Engine
    screen=NNG_EngineInit(game_options);
  
	joy=SDL_JoystickOpen(0);

   // Print game version information
   printf("\nDebian vs Pimientos version: %s - Copyright (c) Hector Blanco de Frutos. 2005\n",game_version.c_str());
   printf("Pubblished by NEOPONTEC under the terms of the GPL license.\n\n");
   // Init the game colors definition 	
   gamecolor=NNG_InitColors();
	
	// Hide/Show the cursor
    SDL_ShowCursor(0);
    
     // Set the window title
    SDL_WM_SetCaption(string("Debian vs Pimientos " + game_version).c_str(),NULL);
   
   
   //Start the game
   game_start();
   printf("\nGame closed\n\n");
  return 0;
}
