/***************************************************************************
 *   Copyright (C) 2005 by Hector Blanco de Frutos                         *
 *   hectorblanco@neopontec.com                                            *
 *   Go to LICENSE file to read the license agreement                      *
 ***************************************************************************/

#include <unistd.h>
#include <string>
#include "../base/engine.h"
#include "screens.h"
#include "../gametypes.h"

using namespace std;

extern NNG_colors gamecolor;
extern SDL_Surface *screen;
extern NNG_EngineOptions game_options;
extern string game_version;


	//Sprites declaration
	NNG_Sprite enemies[ENEMIES];
	NNG_SpriteBase enemybase;
    NNG_Sprite ship1;
	NNG_SpriteBase ship1_base;
    NNG_Sprite fire1[FIRES];
	NNG_SpriteBase fire1_base;
    NNG_Sprite explosion[ENEMIES];
	NNG_SpriteBase explosion_base;	

void game_start(){
    int i;
    string str;
	char str_tmp[256];
    TTF_Font *font;
	//SDLFont *font2;
 	//font2 = initFont("fonts/font2");
    SDL_Surface *text, *nglogo;

   
    font=TTF_OpenFont("fonts/FreeSans.ttf", 16);

    str="Loading game sprites";
	//strcpy(str_tmp,str.c_str());
    text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
	//drawString(screen,font2,24,72, str_tmp);
    DrawIMG(screen, text, 24, 72);
    SDL_Flip(screen);
    for (i=0;i<10;i++){
        SDL_Delay(20);
    }

    // Clear the screen
	SDL_FillRect(screen,NULL,0x010000);

	// Initialize the art
	nglogo=LoadIMG("art/neopontec_games_logo.png");
	DrawIMG(screen, nglogo,0,0);
	SDL_Flip(screen);
	    for (i=0;i<10;i++){
        SDL_Delay(200);
    }
	
    //asteroid1_base.init("art/sprites/asteroid_1");
    //asteroid1.init(&asteroid1_base,screen);    
    ship1_base.init("art/sprites/ship");
    ship1.init(&ship1_base,screen);
    
  	fire1_base.init("art/sprites/fire");
  	enemybase.init("art/sprites/enemies");
	explosion_base.init("art/sprites/explosion");
	
	// We make all the bullets and the enemies use these graphics
  	for(int i=0;i<FIRES;i++)
  	{
    	fire1[i].init(&fire1_base,screen);
  	}
  	for(int i=0;i<ENEMIES;i++)
  	{
    	enemies[i].init(&enemybase,screen);
    	explosion[i].init(&explosion_base,screen);
  	}
	
	
	// Clear the screen
	SDL_FillRect(screen,NULL,0x010000);
	
    str="Game designed and developed";
	//strcpy(str_tmp,str.c_str());
	//drawString(screen,font2,6,32, str_tmp);
    text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
    DrawIMG(screen, text, 6, 64);
    SDL_Flip(screen);
    for (i=0;i<10;i++){
        SDL_Delay(75);
    }
	
    //font=TTF_OpenFont("fonts/FreeSans.ttf", 28);
    str="by  Hector Blanco";
	//strcpy(str_tmp,str.c_str());
	//drawString(screen,font2,20,92, str_tmp);
    text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
    DrawIMG(screen, text, 20, 92);
    SDL_Flip(screen);
    
     // Wait some seconds
     while (i<20*(1)){
       SDL_Delay(100);
       i++;
    }
	// Clear the screen
	SDL_FillRect(screen,NULL,0x010000);
	
    
    str="This game is an homenage to";
	//strcpy(str_tmp,str.c_str());
	//drawString(screen,font2,12,64, str_tmp);
    text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
    DrawIMG(screen, text, 12, 64);
    SDL_Flip(screen);
    
    str="the pople that every day";
	//strcpy(str_tmp,str.c_str());
	//drawString(screen,font2,12,96, str_tmp);
    text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
    DrawIMG(screen, text, 12, 96);
    SDL_Flip(screen);

	str="develops the Debian distro.";
	//strcpy(str_tmp,str.c_str());
 	//drawString(screen,font2,12,128, str_tmp);
    text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
    DrawIMG(screen, text, 12, 128);
    SDL_Flip(screen);
  
    // Wait some seconds
     while (i<75*(1)){
       SDL_Delay(40);
       i++;
    }


    SDL_FreeSurface(nglogo);
	//freeFont(font2);
    TTF_CloseFont(font);
	SDL_Flip(screen);
    
    // Wait some seconds
    i=0;
    while (i<40*(1)){
       SDL_Delay(40);
       i++;
    }
    

    

    screen_mainmenu();
    SDL_FreeSurface(text);
}

void screen_mainmenu(){
	int done=0,i, come_from=1;
	string str;
	char str_tmp[256];
	TTF_Font *font;
    SDL_Surface *text;
    SDL_Surface *title;

	//SDLFont *font2;
    
    // Load the bg image title
    title=LoadIMG("art/title.png");
    
 draw_menu:
    
    //font2 = initFont("fonts/font2");
	// Clear the screen

	SDL_FillRect(screen,NULL,0x010000);
	
	//Draw the bg title
	DrawIMG(screen,title,0,0);
	

	font=TTF_OpenFont("fonts/FreeSans.ttf", 14);
	// Draw the game version
	str = (string)"DVP2X: " + game_version.c_str();
	//strcpy(str_tmp,str.c_str());
	//sprintf(str,"Game version: %s", game_version.c_str());
	text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
	//drawString(screen,font2,180,216, str_tmp);
	DrawIMG(screen, text,210 , 216);
	
	TTF_CloseFont(font);
	// Draw menu items
	
    font=TTF_OpenFont("fonts/FreeSansBold.ttf", 16);
    str="Start a New Game (A)";
	//strcpy(str_tmp,str.c_str());
	//drawString(screen,font2,42,106, str_tmp);
    text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
    DrawIMG(screen, text,60 , 106);
	SDL_FreeSurface(text);
        
    //str="Options (O)";
    //text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
    //DrawIMG(screen, text,400 , 300+40);
    
    str="Credits (B)";
	//strcpy(str_tmp,str.c_str());
	//drawString(screen,font2,42,138, str_tmp);
    text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
    DrawIMG(screen, text,60 , 140);
	SDL_FreeSurface(text);
    
    str="Quit Game (START)";
	strcpy(str_tmp,str.c_str());
	//drawString(screen,font2,42,170, str_tmp);
    text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.white);
    DrawIMG(screen, text,60 , 170);
	SDL_FreeSurface(text);
    
    i=0;
    if (come_from!=0){
		come_from=0;
		while (i<40){
       		SDL_SetAlpha(screen,SDL_SRCALPHA, i+4);
       		SDL_Flip(screen);
       		SDL_Delay(12);
       		i++;
		}
		SDL_SetAlpha(screen,SDL_SRCALPHA, 255);
	}
		
	SDL_Flip(screen);
	//Main while
    while (done!=1)
    {
        SDL_Event event;

        /* Check for events */
        while (SDL_PollEvent (&event))
        {
            //switch (event.type)
            //{ 
            if ((event.type == SDL_KEYDOWN)||(event.type == SDL_JOYBUTTONDOWN))
      		{
                if ((event.jbutton.button == GP2X_BUTTON_START)||(event.key.keysym.sym == SDLK_ESCAPE)) { 
                    done = 1;
                    break;
                }
                if ((event.jbutton.button == GP2X_BUTTON_A)||(event.key.keysym.sym == SDLK_n)){
                	// Close the fonts
					TTF_CloseFont(font);
					//freeFont(font2);
				   	screen_game();
				   	come_from=1;
                	goto draw_menu;
                	break;
                }
                if ((event.jbutton.button == GP2X_BUTTON_B)||(event.key.keysym.sym == SDLK_c)){
                	// Close the fonts
					TTF_CloseFont(font);
					//freeFont(font2);
                	screen_credits();
                	come_from=1;
                	goto draw_menu;	
                	break;
                }
				break;
			}
			
        }
        // Mantain 25fps
		// Close the fonts
        SDL_Delay(40);
    }
	// GP2X: Exit to the console menu
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
}
