/***************************************************************************
 *   Copyright (C) 2005 by Hector Blanco de Frutos                         *
 *   hectorblanco@neopontec.com                                            *
 *   Go to LICENSE file to read the license agreement                      *
 ***************************************************************************/
 
#include <string>
#include <string.h>
#include "../base/engine.h"
#include "../gametypes.h"

using namespace std;

extern NNG_colors gamecolor;
extern SDL_Surface *screen;
extern NNG_EngineOptions game_options;
extern int score;


void screen_pause(){
	int done=0;
	TTF_Font *font;
	//SDLFont *font2;
	SDL_Surface *text;
	SDL_Rect rect1;
	
	rect1.y=113;
    rect1.x=0;
    rect1.h=26;
    rect1.w=320;
    // Clear the zone below the text
    SDL_FillRect(screen,&rect1,0x010000);
    
	// Initialize the fonts
    font=TTF_OpenFont("fonts/FreeSansBold.ttf", 24);
	//font2 = initFont("fonts/font2");
    
    	text=TTF_RenderText_Blended(font,"The Game is paused", gamecolor.white);
    	//drawString(screen,font2,56,106, "The game is PAUSED");
		DrawIMG(screen, text,32 , 108);
    	SDL_FreeSurface(text);
    	SDL_Flip(screen);

		TTF_CloseFont(font);
    
	while (done!=1)
    {
        SDL_Event event;

        /* Check for events */
        while (SDL_PollEvent (&event))
        {
            switch (event.type)
            {
            case SDL_QUIT:
                done = 1;
                break;
                
            //Mouse movement over buttons
            case SDL_KEYDOWN:
                if ( event.key.keysym.sym == SDLK_p ) { 
                    done = 1;
					//freeFont(font2);
                    break;
                }
			case SDL_JOYBUTTONDOWN:
				 if (event.jbutton.button == GP2X_BUTTON_SELECT) { 
                    done = 1;
					//freeFont(font2);
                    break;
                 }
			}
        }
        
        SDL_Delay(40);
        
    }	
}

void screen_gameover(){
	int done=0,i=0;
	TTF_Font *font;
	//SDLFont *font2;
	SDL_Surface *text;
	char str_tmp[256];
	string str;
	

    // Clear screen
    SDL_FillRect(screen,NULL,0x010000);
    
	// Initialize the fonts
    font=TTF_OpenFont("fonts/FreeSansBold.ttf", 32);
	//font2 = initFont("fonts/font2");
    
    	
     while (i<25){
       SDL_SetAlpha(screen,SDL_SRCALPHA, i+10);
       SDL_Flip(screen);
       SDL_Delay(30);
       i++;
     }
     
    
    		
    	//Show 'Game Over'
    	text=TTF_RenderText_Blended(font,"Game Over", gamecolor.white);
    	DrawIMG(screen, text,70 , 64);
    	//drawString(screen,font2,110,64, "GAME OVER");
		SDL_SetAlpha(screen,SDL_SRCALPHA, 255);
		SDL_FreeSurface(text);
    	TTF_CloseFont(font);

		font=TTF_OpenFont("fonts/FreeSansBold.ttf", 24);
    	// Show the score
		sprintf(str_tmp,"Score: %i",score);
    	str = string(str_tmp);
    	text=TTF_RenderText_Blended(font,str.c_str(), gamecolor.yellow);
    	DrawIMG(screen, text,100 , 104);
    	SDL_FreeSurface(text);
		//drawString(screen,font2,100,96, str);
    	//SDL_Flip(screen);
    	
    	//FIX (in 1.0.0). Score is now 0 for new games
    	score=0;
    	//END FIX
    	
    	TTF_CloseFont(font);
    	// Initialize the fonts
    	font=TTF_OpenFont("fonts/FreeSansBold.ttf", 14);
    
    	// Show a message
    	text=TTF_RenderText_Blended(font,"Press START to continue", gamecolor.white);
    	DrawIMG(screen, text,64 , 200);
    	SDL_FreeSurface(text);
    	SDL_Flip(screen);
    	//drawString(screen,font2,32,200, "Press START to continue");
    	TTF_CloseFont(font);
    	
		//freeFont(font2);
    	SDL_Flip(screen);
    	
	while (done!=1)
    {
        SDL_Event event;

        /* Check for events */
        while (SDL_PollEvent (&event))
        {
            switch (event.type)
            {
            case SDL_QUIT:
                done = 1;
                
                break;
                
            //Mouse movement over buttons
            case SDL_KEYDOWN:
                if ( event.key.keysym.sym == SDLK_RETURN || event.key.keysym.sym == SDLK_ESCAPE ) { 
                    done = 1;
                    break;
                }
			case SDL_JOYBUTTONDOWN:
				 if (event.jbutton.button == GP2X_BUTTON_START) {
				 	done = 1;
                    break;
				 }
            }
        }
        
        SDL_Delay(40);
        
    }
    
}
